Automate installation of DXVK, D9VK + Wine/Wine Staging & update GPU drivers + PlayonLinux wineprefixes (Debian/Ubuntu/Mint/Arch Linux/Manjaro)
You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.

387 lines
11 KiB

5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
  1. #!/bin/env bash
  2. # DXVK/Wine-Staging scripts dispatcher for various Linux distributions
  3. # Copyright (C) 2019 Pekka Helenius
  4. #
  5. # This program is free software: you can redistribute it and/or modify
  6. # it under the terms of the GNU General Public License as published by
  7. # the Free Software Foundation, either version 3 of the License, or
  8. # (at your option) any later version.
  9. #
  10. # This program is distributed in the hope that it will be useful,
  11. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  12. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  13. # GNU General Public License for more details.
  14. #
  15. # You should have received a copy of the GNU General Public License
  16. # along with this program. If not, see <https://www.gnu.org/licenses/>.
  17. ##############################################################################
  18. # Check if we're using bash or sh to run the script. If bash, OK.
  19. # If another one, ask user to run the script with bash.
  20. BASH_CHECK=$(ps | grep `echo $$` | awk '{ print $4 }')
  21. if [ $BASH_CHECK != "bash" ]; then
  22. echo "
  23. Please run this script using bash (/usr/bin/bash).
  24. "
  25. exit 1
  26. fi
  27. ###########################################################
  28. # Just a title & author for this script, used in initialization and help page
  29. SCRIPT_TITLE="\e[1mWine/Wine Staging & DXVK package builder & auto-installer\e[0m"
  30. SCRIPT_AUTHOR="Pekka Helenius (~Fincer), 2019"
  31. ########################################################
  32. # Should we freeze Git versions of these packages?
  33. # This is handy in some cases, if breakages occur
  34. # (although we actually compile an older version of a package)
  35. #
  36. # Define a commit hash to freeze to
  37. # Use keyword 'HEAD' if you want to use the latest git
  38. # version available
  39. # Do NOT leave these variable empty!
  40. git_commithash_dxvk=HEAD
  41. git_branch_dxvk=master
  42. git_commithash_wine=HEAD
  43. git_branch_wine=master
  44. # These apply only on Debian/Ubuntu/Mint
  45. git_commithash_meson=5d6dcf8850fcc5d552f55943b6aa3582754dedf8
  46. git_branch_meson=master
  47. git_commithash_glslang=HEAD
  48. git_branch_glslang=master
  49. ###########################################################
  50. # Allow interruption of the script at any time (Ctrl + C)
  51. trap "exit" INT
  52. ###########################################################
  53. COMMANDS=(
  54. date
  55. df
  56. find
  57. git
  58. grep
  59. groups
  60. nproc
  61. patch
  62. readlink
  63. sudo
  64. tar
  65. uname
  66. wc
  67. wget
  68. )
  69. function checkCommands() {
  70. if [[ $(which --help 2>/dev/null) ]] && [[ $(echo --help 2>/dev/null) ]]; then
  71. local a=0
  72. for command in ${@}; do
  73. if [[ ! $(which $command 2>/dev/null) ]]; then
  74. local COMMANDS_NOTFOUND[$a]=${command}
  75. let a++
  76. fi
  77. done
  78. if [[ -n $COMMANDS_NOTFOUND ]]; then
  79. echo -e "\nError! The following commands could not be found: ${COMMANDS_NOTFOUND[*]}\nAborting\n"
  80. exit 1
  81. fi
  82. else
  83. exit 1
  84. fi
  85. }
  86. checkCommands "${COMMANDS[*]}"
  87. ###########################################################
  88. # http://wiki.bash-hackers.org/snipplets/print_horizontal_line#a_line_across_the_entire_width_of_the_terminal
  89. function INFO_SEP() { printf '%*s\n' "${COLUMNS:-$(tput cols)}" '' | tr ' ' - ; }
  90. ###########################################################
  91. if [[ $(uname -a | grep -c x86_64) -eq 0 ]]; then
  92. echo "This script supports 64-bit architectures only."
  93. exit 1
  94. fi
  95. if [[ $(groups | grep -c sudo) -eq 0 ]]; then
  96. echo "You must belong to sudo group."
  97. exit 1
  98. fi
  99. if [[ $UID -eq 0 ]]; then
  100. echo "Run as a regular user."
  101. exit 1
  102. fi
  103. ###########################################################
  104. # User-passed arguments for the script
  105. # We check the values of this array
  106. # and pass them to the subscripts if supported
  107. i=0
  108. for arg in ${@}; do
  109. case ${arg} in
  110. --no-staging)
  111. # Do not build Wine staging version, just Wine
  112. ;;
  113. --no-install)
  114. # Just build, do not install DXVK or Wine-Staging
  115. # Note that some version of Wine is required for DXVK compilation, though!
  116. ;;
  117. --no-wine)
  118. # Skip Wine build & installation process all together
  119. NO_WINE=
  120. ;;
  121. --no-dxvk)
  122. # Skip DXVK build & installation process all together
  123. NO_DXVK=
  124. ;;
  125. --no-pol)
  126. # Skip PlayOnLinux Wine prefixes update process
  127. ;;
  128. *)
  129. echo -e "\n\
  130. \
  131. ${SCRIPT_TITLE} by ${SCRIPT_AUTHOR}\n\n\
  132. Usage:\n\nbash updatewine.sh\n\nArguments:\n\n\
  133. --no-install\tDo not install Wine or DXVK. Just compile them. Wine, meson & glslang must be installed for DXVK compilation.\n\
  134. --no-dxvk\tDo not compile or install DXVK\n\
  135. --no-pol\tDo not update PlayOnLinux Wine prefixes\n\n\
  136. --no-staging\tCompile Wine instead of Wine Staging\n\
  137. --no-wine\tDo not compile or install Wine/Wine Staging\n\n\
  138. Compiled packages are installed by default, unless '--no-install' argument is given.\n\
  139. If '--no-install' argument is given, the script doesn't check or update your PlayOnLinux Wine prefixes.\n"
  140. exit 0
  141. ;;
  142. esac
  143. args[$i]="${arg}"
  144. let i++
  145. done
  146. ###########################################################
  147. # Date timestamp and random number identifier for compiled
  148. # DXVK & Wine Staging builds
  149. # This variable is known as 'datedir' in other script files
  150. datesuffix=$(echo $(date '+%Y-%m-%d-%H%M%S'))
  151. ###########################################################
  152. # Add git commit hash overrides to argument list
  153. # Pass them to subscripts, as well.
  154. githash_overrides=(
  155. "${git_commithash_dxvk}"
  156. "${git_commithash_glslang}"
  157. "${git_commithash_meson}"
  158. "${git_commithash_wine}"
  159. )
  160. # Add git branches to argument list
  161. # Pass them to subscripts, as well.
  162. gitbranch_overrides=(
  163. "${git_branch_dxvk}"
  164. "${git_branch_glslang}"
  165. "${git_branch_meson}"
  166. "${git_branch_wine}"
  167. )
  168. #############################
  169. # Commit syntax validity check
  170. for githash in ${githash_overrides[@]}; do
  171. if [[ ! $(printf ${githash} | wc -c) -eq 40 ]] && \
  172. [[ ! ${githash} == HEAD ]]; then
  173. echo -e "\nError: badly formatted commit hash '${githash}' in the script file 'updatewine.sh'. Aborting\n"
  174. exit 1
  175. fi
  176. done
  177. ###########################################################
  178. params=(${datesuffix} ${githash_overrides[@]} ${gitbranch_overrides[@]} ${args[@]})
  179. ###########################################################
  180. # General function for question responses
  181. function questionresponse() {
  182. local response=${1}
  183. read -r -p "" response
  184. if [[ $(echo $response | sed 's/ //g') =~ ^([yY][eE][sS]|[yY])$ ]]; then
  185. echo ""
  186. return 0
  187. else
  188. return 1
  189. fi
  190. }
  191. ###########################################################
  192. function reqsCheck() {
  193. local AVAIL_SPACE=$(df -h -B MB --output=avail . | sed '1d; s/[A-Z]*//g')
  194. local REC_SPACE=8000
  195. local MSG_SPACE="\e[1mWARNING:\e[0m Not sufficient storage space\n\nYou will possibly run out of space while compiling software.\n\
  196. The script strongly recommends ~\e[1m$((${REC_SPACE} / 1000)) GB\e[0m at least to compile software successfully but you have only\n\
  197. \e[1m${AVAIL_SPACE} MB\e[0m left on the filesystem the script is currently placed at.\n\n\
  198. Be aware that the script process may fail because of this, especially while compiling Wine Staging.\n\n\
  199. Do you really want to continue? [Y/n]"
  200. local AVAIL_RAM=$(( $(grep -oP "(?<=^MemFree:).*[0-9]" /proc/meminfo | sed 's/ //g') / 1024 ))
  201. local REC_RAM=4096
  202. local MSG_RAM="\e[1mWARNING:\e[0m Not sufficient RAM available\n\nCompilation processes will likely fail.\n\
  203. The script strongly recommends ~\e[1m${REC_RAM} MB\e[0m at least to compile software successfully but you have only\n\
  204. \e[1m${AVAIL_RAM} MB\e[0m left on the computer the script is currently placed at.\n\n\
  205. Be aware that the script process may fail because of this, especially while compiling DXVK.\n\n\
  206. Do you really want to continue? [Y/n]"
  207. function reqs_property() {
  208. local avail_prop="${1}"
  209. local req_prop="${2}"
  210. local req_message="${3}"
  211. local req_installtargets="${4}"
  212. local i=0
  213. for req_installtarget in ${req_installtargets}; do
  214. req_targetconditions[$i]=$(echo "[[ ! -v ${req_installtarget} ]] ||")
  215. let i++
  216. done
  217. local req_targetconditions=($(echo ${req_targetconditions[@]} | sed 's/\(.*\) ||/\1 /'))
  218. local fullcondition="[[ "${avail_prop}" -lt "${req_prop}" ]] && ($(echo ${req_targetconditions[@]}))"
  219. if $(eval ${fullcondition}); then
  220. INFO_SEP
  221. echo -e "${req_message}"
  222. questionresponse
  223. if [[ $? -ne 0 ]]; then
  224. echo -e "Cancelling.\n"
  225. exit 1
  226. fi
  227. unset avail_prop req_prop req_installtarget req_targetconditions fullcondition
  228. fi
  229. }
  230. reqs_property "${AVAIL_SPACE}" "${REC_SPACE}" "${MSG_SPACE}" "NO_WINE"
  231. reqs_property "${AVAIL_RAM}" "${REC_RAM}" "${MSG_RAM}" "NO_DXVK"
  232. }
  233. ###########################################################
  234. function sudoQuestion() {
  235. sudo -k
  236. echo -e "\e[1mINFO:\e[0m sudo password required\n\nThis script requires elevated permissions for package updates & installations. Please provide your sudo password for these script commands. Sudo permissions are not used for any other purposes.\n"
  237. sudo -v
  238. if [[ $? -ne 0 ]]; then
  239. echo -e "Invalid sudo password.\n"
  240. exit 1
  241. fi
  242. # PID of the current main process
  243. PIDOF=$$
  244. # Run sudo timestamp update on the background and continue the script execution
  245. # Refresh sudo timestamp while the main process is running
  246. function sudo_refresh() {
  247. while [[ $(printf $(ps ax -o pid --no-headers | grep -o ${PIDOF} &> /dev/null)$?) -eq 0 ]]; do
  248. sudo -nv && sleep 2
  249. done
  250. }
  251. sudo_refresh &
  252. }
  253. ###########################################################
  254. function checkInternet() {
  255. if [[ $(echo $(wget --delete-after -q -T 5 github.com -o -)$?) -ne 0 ]]; then
  256. echo -e "\nDNS name resolution failed (GitHub). Please check your network connection settings and try again.\n"
  257. exit 1
  258. fi
  259. rm -f ./index.html.tmp
  260. }
  261. checkInternet
  262. ###########################################################
  263. # Only Debian & Arch based Linux distributions are currently supported
  264. function determineDistroFamily() {
  265. # These are default package managers used by the supported Linux distributions
  266. pkgmgrs=('dpkg' 'pacman')
  267. for pkgmgr in ${pkgmgrs[@]}; do
  268. if [[ $(printf $(which ${pkgmgr} &> /dev/null)$?) -eq 0 ]]; then
  269. pkgmgr_valid=${pkgmgr}
  270. fi
  271. done
  272. case ${pkgmgr_valid} in
  273. dpkg)
  274. distro="debian"
  275. ;;
  276. pacman)
  277. distro="arch"
  278. ;;
  279. default|*)
  280. echo -e "Your Linux distribution is not supported. Aborting.\n"
  281. exit 1
  282. ;;
  283. esac
  284. }
  285. if [[ ! -v NO_WINE ]] || [[ ! -v NO_DXVK ]]; then
  286. echo -e "\n${SCRIPT_TITLE}\n\nBuild identifier:\t${datesuffix}\n"
  287. else
  288. echo ""
  289. fi
  290. if [[ -n ${args[*]} ]]; then
  291. echo -e "Using arguments:\t${args[*]}\n"
  292. fi
  293. determineDistroFamily
  294. INFO_SEP
  295. echo -e "\e[1mNOTE: \e[0mDXVK requires very latest Nvidia/AMD drivers to work.\nMake sure these drivers are available on your Linux distribution.\n\
  296. This script comes with GPU driver installation scripts for Debian-based Linux distributions.\n"
  297. INFO_SEP
  298. if [[ ! -v NO_WINE ]] || [[ ! -v NO_DXVK ]]; then
  299. reqsCheck
  300. sudoQuestion
  301. echo ""
  302. fi
  303. bash -c "cd ${distro} && bash ./updatewine_${distro}.sh ${params[*]}"